diff --git a/src/system/libroot/posix/glibc/libio/iopopen.c b/src/system/libroot/posix/glibc/libio/iopopen.c
index 7654de4f88..5d2ce4a571 100644
--- a/src/system/libroot/posix/glibc/libio/iopopen.c
+++ b/src/system/libroot/posix/glibc/libio/iopopen.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993, 1997-2002, 2003 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
    Written by Per Bothner <bothner@cygnus.com>.
 
@@ -13,9 +13,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -29,25 +28,55 @@
 #ifndef _POSIX_SOURCE
 # define _POSIX_SOURCE
 #endif
-
-#include <sys/types.h>
-#include <sys/wait.h>
 #include "libioP.h"
-#if _IO_HAVE_SYS_WAIT
 #include <signal.h>
 #include <unistd.h>
-#ifdef __STDC__
 #include <stdlib.h>
-#endif
 #ifdef _LIBC
 # include <unistd.h>
 # include <shlib-compat.h>
+# include <not-cancel.h>
+#endif
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#ifndef __HAIKU__
+#include <kernel-features.h>
+#else
+#define __ASSUME_PIPE2
 #endif
 
-#endif /* _IO_HAVE_SYS_WAIT */
+#ifndef _IO_fork
+#define _IO_fork fork
+extern _IO_pid_t _IO_fork (void) __THROW;
+#endif
+
+#ifndef _IO_dup2
+#define _IO_dup2 dup2
+extern int _IO_dup2 (int fd, int fd2) __THROW;
+#endif
+
+#ifndef _IO_waitpid
+#ifdef _LIBC
+#define _IO_waitpid waitpid_not_cancel
+#else
+#define _IO_waitpid waitpid
+#endif
+#endif
+
+#ifndef _IO_execl
+#define _IO_execl execl
+#endif
+#ifndef _IO__exit
+#define _IO__exit _exit
+#endif
 
 #ifndef _IO_close
-#	define _IO_close close
+#ifdef _LIBC
+#define _IO_close close_not_cancel
+#else
+#define _IO_close close
+#endif
 #endif
 
 struct _IO_proc_file
@@ -59,22 +88,19 @@ struct _IO_proc_file
 };
 typedef struct _IO_proc_file _IO_proc_file;
 
-static struct _IO_jump_t _IO_proc_jumps;
-static struct _IO_jump_t _IO_wproc_jumps;
+static const struct _IO_jump_t _IO_proc_jumps;
 
 static struct _IO_proc_file *proc_file_chain;
 
 #ifdef _IO_MTSAFE_IO
 static _IO_lock_t proc_file_chain_lock = _IO_lock_initializer;
 
-#if 0
 static void
 unlock (void *not_used)
 {
   _IO_lock_unlock (proc_file_chain_lock);
 }
 #endif
-#endif
 
 _IO_FILE *
 _IO_new_proc_open (fp, command, mode)
@@ -82,54 +108,119 @@ _IO_new_proc_open (fp, command, mode)
      const char *command;
      const char *mode;
 {
-#if _IO_HAVE_SYS_WAIT
-  volatile int read_or_write;
-  volatile int parent_end, child_end;
+  int read_or_write;
+  int parent_end, child_end;
   int pipe_fds[2];
   _IO_pid_t child_pid;
+
+  int do_read = 0;
+  int do_write = 0;
+  int do_cloexec = 0;
+  while (*mode != '\0')
+    switch (*mode++)
+      {
+      case 'r':
+	do_read = 1;
+	break;
+      case 'w':
+	do_write = 1;
+	break;
+      case 'e':
+	do_cloexec = 1;
+	break;
+      default:
+      errout:
+	__set_errno (EINVAL);
+	return NULL;
+      }
+
+  if ((do_read ^ do_write) == 0)
+    goto errout;
+
   if (_IO_file_is_open (fp))
     return NULL;
-  if (pipe(pipe_fds) < 0)
-    return NULL;
-  if (mode[0] == 'r' && mode[1] == '\0')
+
+#ifdef O_CLOEXEC
+# ifndef __ASSUME_PIPE2
+  if (__have_pipe2 >= 0)
+# endif
+    {
+      int r = __pipe2 (pipe_fds, O_CLOEXEC);
+# ifndef __ASSUME_PIPE2
+      if (__have_pipe2 == 0)
+	__have_pipe2 = r != -1 || errno != ENOSYS ? 1 : -1;
+
+      if (__have_pipe2 > 0)
+# endif
+	if (r < 0)
+	  return NULL;
+    }
+#endif
+#ifndef __ASSUME_PIPE2
+# ifdef O_CLOEXEC
+  if (__have_pipe2 < 0)
+# endif
+    if (__pipe (pipe_fds) < 0)
+      return NULL;
+#endif
+
+  if (do_read)
     {
       parent_end = pipe_fds[0];
       child_end = pipe_fds[1];
       read_or_write = _IO_NO_WRITES;
     }
-  else if (mode[0] == 'w' && mode[1] == '\0')
+  else
     {
       parent_end = pipe_fds[1];
       child_end = pipe_fds[0];
       read_or_write = _IO_NO_READS;
     }
-  else
-    {
-      _IO_close (pipe_fds[0]);
-      _IO_close (pipe_fds[1]);
-      __set_errno (EINVAL);
-      return NULL;
-    }
-  ((_IO_proc_file *) fp)->pid = child_pid = fork();
+
+  ((_IO_proc_file *) fp)->pid = child_pid = _IO_fork ();
   if (child_pid == 0)
     {
-      int child_std_end = mode[0] == 'r' ? 1 : 0;
+      int child_std_end = do_read ? 1 : 0;
       struct _IO_proc_file *p;
 
+#ifndef __ASSUME_PIPE2
+      /* If we have pipe2 the descriptor is marked for close-on-exec.  */
       _IO_close (parent_end);
+#endif
       if (child_end != child_std_end)
 	{
-	  dup2(child_end, child_std_end);
+	  _IO_dup2 (child_end, child_std_end);
+#ifndef __ASSUME_PIPE2
 	  _IO_close (child_end);
+#endif
+	}
+#ifdef O_CLOEXEC
+      else
+	{
+	  /* The descriptor is already the one we will use.  But it must
+	     not be marked close-on-exec.  Undo the effects.  */
+# ifndef __ASSUME_PIPE2
+	  if (__have_pipe2 > 0)
+# endif
+	    __fcntl (child_end, F_SETFD, 0);
 	}
+#endif
       /* POSIX.2:  "popen() shall ensure that any streams from previous
          popen() calls that remain open in the parent process are closed
 	 in the new child process." */
       for (p = proc_file_chain; p; p = p->next)
-	_IO_close (_IO_fileno ((_IO_FILE *) p));
+	{
+	  int fd = _IO_fileno ((_IO_FILE *) p);
+
+	  /* If any stream from previous popen() calls has fileno
+	     child_std_end, it has been already closed by the dup2 syscall
+	     above.  */
+	  if (fd != child_std_end)
+	    _IO_close (fd);
+	}
 
-      execl("/bin/sh", "sh", "-c", command, (char *)0);
-      _exit(127);
+      _IO_execl ("/bin/sh", "sh", "-c", command, (char *) 0);
+      _IO__exit (127);
     }
   _IO_close (child_end);
   if (child_pid < 0)
@@ -137,6 +228,28 @@ _IO_new_proc_open (fp, command, mode)
       _IO_close (parent_end);
       return NULL;
     }
+
+  if (do_cloexec)
+    {
+#ifndef __ASSUME_PIPE2
+# ifdef O_CLOEXEC
+      if (__have_pipe2 < 0)
+# endif
+	__fcntl (parent_end, F_SETFD, FD_CLOEXEC);
+#endif
+    }
+  else
+    {
+#ifdef O_CLOEXEC
+      /* Undo the effects of the pipe2 call which set the
+	 close-on-exec flag.  */
+# ifndef __ASSUME_PIPE2
+      if (__have_pipe2 > 0)
+# endif
+	__fcntl (parent_end, F_SETFD, 0);
+#endif
+    }
+
   _IO_fileno (fp) = parent_end;
 
   /* Link into proc_file_chain. */
@@ -153,9 +266,6 @@ _IO_new_proc_open (fp, command, mode)
 
   _IO_mask_flags (fp, read_or_write, _IO_NO_READS|_IO_NO_WRITES);
   return fp;
-#else /* !_IO_HAVE_SYS_WAIT */
-  return NULL;
-#endif
 }
 
 _IO_FILE *
@@ -169,7 +279,6 @@ _IO_new_popen (command, mode)
 #ifdef _IO_MTSAFE_IO
     _IO_lock_t lock;
 #endif
-    struct _IO_wide_data wd;
   } *new_f;
   _IO_FILE *fp;
 
@@ -180,7 +289,7 @@ _IO_new_popen (command, mode)
   new_f->fpx.file.file._lock = &new_f->lock;
 #endif
   fp = &new_f->fpx.file.file;
-  _IO_no_init (fp, 0, 0, &new_f->wd, &_IO_wproc_jumps);
+  _IO_init (fp, 0);
   _IO_JUMPS (&new_f->fpx.file) = &_IO_proc_jumps;
   _IO_new_file_init (&new_f->fpx.file);
 #if  !_IO_UNIFIED_JUMPTABLES
@@ -188,7 +297,7 @@ _IO_new_popen (command, mode)
 #endif
   if (_IO_new_proc_open (fp, command, mode) != NULL)
     return (_IO_FILE *) &new_f->fpx.file;
-  INTUSE(_IO_un_link) (&new_f->fpx.file);
+  _IO_un_link (&new_f->fpx.file);
   free (new_f);
   return NULL;
 }
@@ -198,7 +307,6 @@ _IO_new_proc_close (fp)
      _IO_FILE *fp;
 {
   /* This is not name-space clean. FIXME! */
-#if _IO_HAVE_SYS_WAIT
   int wstatus;
   _IO_proc_file **ptr = &proc_file_chain;
   _IO_pid_t wait_pid;
@@ -231,59 +339,33 @@ _IO_new_proc_close (fp)
      described in POSIX.2, such implementations are not conforming." */
   do
     {
-      wait_pid = waitpid(((_IO_proc_file *) fp)->pid, &wstatus, 0);
+      wait_pid = _IO_waitpid (((_IO_proc_file *) fp)->pid, &wstatus, 0);
     }
   while (wait_pid == -1 && errno == EINTR);
   if (wait_pid == -1)
     return -1;
   return wstatus;
-#else /* !_IO_HAVE_SYS_WAIT */
-  return -1;
-#endif
 }
 
-static struct _IO_jump_t _IO_proc_jumps = {
-  JUMP_INIT_DUMMY,
-  JUMP_INIT(finish, _IO_new_file_finish),
-  JUMP_INIT(overflow, _IO_new_file_overflow),
-  JUMP_INIT(underflow, _IO_new_file_underflow),
-  JUMP_INIT(uflow, INTUSE(_IO_default_uflow)),
-  JUMP_INIT(pbackfail, INTUSE(_IO_default_pbackfail)),
-  JUMP_INIT(xsputn, _IO_new_file_xsputn),
-  JUMP_INIT(xsgetn, INTUSE(_IO_default_xsgetn)),
-  JUMP_INIT(seekoff, _IO_new_file_seekoff),
-  JUMP_INIT(seekpos, _IO_default_seekpos),
-  JUMP_INIT(setbuf, _IO_new_file_setbuf),
-  JUMP_INIT(sync, _IO_new_file_sync),
-  JUMP_INIT(doallocate, INTUSE(_IO_file_doallocate)),
-  JUMP_INIT(read, INTUSE(_IO_file_read)),
-  JUMP_INIT(write, _IO_new_file_write),
-  JUMP_INIT(seek, INTUSE(_IO_file_seek)),
-  JUMP_INIT(close, _IO_new_proc_close),
-  JUMP_INIT(stat, INTUSE(_IO_file_stat)),
-  JUMP_INIT(showmanyc, _IO_default_showmanyc),
-  JUMP_INIT(imbue, _IO_default_imbue)
-};
-
-static struct _IO_jump_t _IO_wproc_jumps = {
+static const struct _IO_jump_t _IO_proc_jumps = {
   JUMP_INIT_DUMMY,
   JUMP_INIT(finish, _IO_new_file_finish),
   JUMP_INIT(overflow, _IO_new_file_overflow),
   JUMP_INIT(underflow, _IO_new_file_underflow),
-  JUMP_INIT(uflow, INTUSE(_IO_default_uflow)),
-  JUMP_INIT(pbackfail, INTUSE(_IO_default_pbackfail)),
+  JUMP_INIT(uflow, _IO_default_uflow),
+  JUMP_INIT(pbackfail, _IO_default_pbackfail),
   JUMP_INIT(xsputn, _IO_new_file_xsputn),
-  JUMP_INIT(xsgetn, INTUSE(_IO_default_xsgetn)),
+  JUMP_INIT(xsgetn, _IO_default_xsgetn),
   JUMP_INIT(seekoff, _IO_new_file_seekoff),
   JUMP_INIT(seekpos, _IO_default_seekpos),
   JUMP_INIT(setbuf, _IO_new_file_setbuf),
   JUMP_INIT(sync, _IO_new_file_sync),
-  JUMP_INIT(doallocate, INTUSE(_IO_file_doallocate)),
-  JUMP_INIT(read, INTUSE(_IO_file_read)),
+  JUMP_INIT(doallocate, _IO_file_doallocate),
+  JUMP_INIT(read, _IO_file_read),
   JUMP_INIT(write, _IO_new_file_write),
-  JUMP_INIT(seek, INTUSE(_IO_file_seek)),
+  JUMP_INIT(seek, _IO_file_seek),
   JUMP_INIT(close, _IO_new_proc_close),
-  JUMP_INIT(stat, INTUSE(_IO_file_stat)),
+  JUMP_INIT(stat, _IO_file_stat),
   JUMP_INIT(showmanyc, _IO_default_showmanyc),
   JUMP_INIT(imbue, _IO_default_imbue)
 };
diff --git a/src/system/libroot/posix/glibc/libio/ioputs.c b/src/system/libroot/posix/glibc/libio/ioputs.c
index 047db0c0a0..e6d5c141f8 100644
--- a/src/system/libroot/posix/glibc/libio/ioputs.c
+++ b/src/system/libroot/posix/glibc/libio/ioputs.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993, 1996, 1997, 1998, 1999 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -23,34 +22,31 @@
    however invalidate any other reasons why the executable file
    might be covered by the GNU Lesser General Public License.
    This exception applies to code released by its copyright holders
-   in files containing the exception.
-*/
-
+   in files containing the exception.  */
 
 #include "libioP.h"
 #include <string.h>
-
+#include <limits.h>
+#include <sys/param.h>
 
 int
-_IO_puts(const char *str)
+_IO_puts (str)
+     const char *str;
 {
-	int result = EOF;
-	_IO_size_t len = strlen(str);
-
-	_IO_cleanup_region_start((void (*) __P ((void *))) _IO_funlockfile, _IO_stdout);
-	_IO_flockfile(_IO_stdout);
-
-	if ((_IO_stdout->_vtable_offset != 0 || _IO_fwide(_IO_stdout, -1) == -1)
-		&& _IO_sputn(_IO_stdout, str, len) == len
-		&& _IO_putc_unlocked('\n', _IO_stdout) != EOF)
-		result = len + 1;
-
-	_IO_funlockfile(_IO_stdout);
-	_IO_cleanup_region_end(0);
-
-	return result;
+  int result = EOF;
+  _IO_size_t len = strlen (str);
+  _IO_acquire_lock (_IO_stdout);
+
+  if ((_IO_vtable_offset (_IO_stdout) != 0
+       || _IO_fwide (_IO_stdout, -1) == -1)
+      && _IO_sputn (_IO_stdout, str, len) == len
+      && _IO_putc_unlocked ('\n', _IO_stdout) != EOF)
+    result = MIN (INT_MAX, len + 1);
+
+  _IO_release_lock (_IO_stdout);
+  return result;
 }
 
 #ifdef weak_alias
-weak_alias(_IO_puts, puts)
+weak_alias (_IO_puts, puts)
 #endif
diff --git a/src/system/libroot/posix/glibc/libio/ioseekoff.c b/src/system/libroot/posix/glibc/libio/ioseekoff.c
index 154a343ced..fdb7968149 100644
--- a/src/system/libroot/posix/glibc/libio/ioseekoff.c
+++ b/src/system/libroot/posix/glibc/libio/ioseekoff.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993,1997,1998,1999,2001,2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -25,9 +24,15 @@
    This exception applies to code released by its copyright holders
    in files containing the exception.  */
 
-#include <libioP.h>
 #include <stdlib.h>
+#include <libioP.h>
 #include <errno.h>
+#ifndef errno
+extern int errno;
+#endif
+#ifndef __set_errno
+# define __set_errno(Val) errno = (Val)
+#endif
 
 _IO_off64_t
 _IO_seekoff_unlocked (fp, offset, dir, mode)
@@ -50,15 +55,15 @@ _IO_seekoff_unlocked (fp, offset, dir, mode)
     {
       if (dir == _IO_seek_cur && _IO_in_backup (fp))
 	{
-	  if (fp->_vtable_offset != 0 || fp->_mode <= 0)
+	  if (_IO_vtable_offset (fp) != 0 || fp->_mode <= 0)
 	    offset -= fp->_IO_read_end - fp->_IO_read_ptr;
 	  else
 	    abort ();
 	}
       if (_IO_fwide (fp, 0) < 0)
-	INTUSE(_IO_free_backup_area) (fp);
+	_IO_free_backup_area (fp);
       else
-	INTUSE(_IO_free_wbackup_area) (fp);
+	_IO_free_wbackup_area (fp);
     }
 
   return _IO_SEEKOFF (fp, offset, dir, mode);
@@ -74,12 +79,8 @@ _IO_seekoff (fp, offset, dir, mode)
 {
   _IO_off64_t retval;
 
-  _IO_cleanup_region_start ((void (*) __P ((void *))) _IO_funlockfile, fp);
-  _IO_flockfile (fp);
-
+  _IO_acquire_lock (fp);
   retval = _IO_seekoff_unlocked (fp, offset, dir, mode);
-
-  _IO_funlockfile (fp);
-  _IO_cleanup_region_end (0);
+  _IO_release_lock (fp);
   return retval;
 }
diff --git a/src/system/libroot/posix/glibc/libio/ioseekpos.c b/src/system/libroot/posix/glibc/libio/ioseekpos.c
index 1cb38dd28a..45b656751c 100644
--- a/src/system/libroot/posix/glibc/libio/ioseekpos.c
+++ b/src/system/libroot/posix/glibc/libio/ioseekpos.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993, 1997, 1998, 1999, 2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -23,44 +22,44 @@
    however invalidate any other reasons why the executable file
    might be covered by the GNU Lesser General Public License.
    This exception applies to code released by its copyright holders
-   in files containing the exception.
-*/
-
+   in files containing the exception.  */
 
 #include <libioP.h>
 
-
 _IO_off64_t
-_IO_seekpos_unlocked(_IO_FILE *fp, _IO_off64_t pos, int mode)
+_IO_seekpos_unlocked (fp, pos, mode)
+     _IO_FILE *fp;
+     _IO_off64_t pos;
+     int mode;
 {
-	/* If we have a backup buffer, get rid of it, since the __seekoff
-	 * callback may not know to do the right thing about it.
-	 * This may be over-kill, but it'll do for now. TODO
-	 */
-
-	if (_IO_fwide(fp, 0) <= 0) {
-		if (_IO_have_backup(fp))
-			INTUSE(_IO_free_backup_area)(fp);
-	} else {
-		if (_IO_have_wbackup(fp))
-			INTUSE(_IO_free_wbackup_area)(fp);
-	}
+  /* If we have a backup buffer, get rid of it, since the __seekoff
+     callback may not know to do the right thing about it.
+     This may be over-kill, but it'll do for now. TODO */
+  if (_IO_fwide (fp, 0) <= 0)
+    {
+      if (_IO_have_backup (fp))
+	_IO_free_backup_area (fp);
+    }
+  else
+    {
+      if (_IO_have_wbackup (fp))
+	_IO_free_wbackup_area (fp);
+    }
 
-	return _IO_SEEKPOS(fp, pos, mode);
+  return _IO_SEEKOFF (fp, pos, 0, mode);
 }
 
 
 _IO_off64_t
-_IO_seekpos(_IO_FILE *fp, _IO_off64_t pos, int mode)
+_IO_seekpos (fp, pos, mode)
+     _IO_FILE *fp;
+     _IO_off64_t pos;
+     int mode;
 {
-	_IO_off64_t retval;
-
-	_IO_cleanup_region_start((void (*) __P ((void *)))_IO_funlockfile, fp);
-	_IO_flockfile(fp);
-
-	retval = _IO_seekpos_unlocked(fp, pos, mode);
+  _IO_off64_t retval;
 
-	_IO_funlockfile(fp);
-	_IO_cleanup_region_end(0);
-	return retval;
+  _IO_acquire_lock (fp);
+  retval = _IO_seekpos_unlocked (fp, pos, mode);
+  _IO_release_lock (fp);
+  return retval;
 }
diff --git a/src/system/libroot/posix/glibc/libio/iosetbuffer.c b/src/system/libroot/posix/glibc/libio/iosetbuffer.c
index 785fcab4bd..31b0bbca09 100644
--- a/src/system/libroot/posix/glibc/libio/iosetbuffer.c
+++ b/src/system/libroot/posix/glibc/libio/iosetbuffer.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993,95,96,97,98,99,2000,2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -34,19 +33,17 @@ _IO_setbuffer (fp, buf, size)
      _IO_size_t size;
 {
   CHECK_FILE (fp, );
-  _IO_cleanup_region_start ((void (*) (void *)) _IO_funlockfile, fp);
-  _IO_flockfile (fp);
+  _IO_acquire_lock (fp);
   fp->_flags &= ~_IO_LINE_BUF;
   if (!buf)
     size = 0;
   (void) _IO_SETBUF (fp, buf, size);
-  if (fp->_vtable_offset == 0 && fp->_mode == 0 && _IO_CHECK_WIDE (fp))
+  if (_IO_vtable_offset (fp) == 0 && fp->_mode == 0 && _IO_CHECK_WIDE (fp))
     /* We also have to set the buffer using the wide char function.  */
     (void) _IO_WSETBUF (fp, buf, size);
-  _IO_funlockfile (fp);
-  _IO_cleanup_region_end (0);
+  _IO_release_lock (fp);
 }
-INTDEF(_IO_setbuffer)
+libc_hidden_def (_IO_setbuffer)
 
 #ifdef weak_alias
 weak_alias (_IO_setbuffer, setbuffer)
diff --git a/src/system/libroot/posix/glibc/libio/iosetvbuf.c b/src/system/libroot/posix/glibc/libio/iosetvbuf.c
index 06d9f73fc4..d97e4820af 100644
--- a/src/system/libroot/posix/glibc/libio/iosetvbuf.c
+++ b/src/system/libroot/posix/glibc/libio/iosetvbuf.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993,96,97,98,99,2000,2001,2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -40,12 +39,11 @@ _IO_setvbuf (fp, buf, mode, size)
 {
   int result;
   CHECK_FILE (fp, EOF);
-  _IO_cleanup_region_start ((void (*) (void *)) _IO_funlockfile, fp);
-  _IO_flockfile (fp);
+  _IO_acquire_lock (fp);
   switch (mode)
     {
     case _IOFBF:
-      fp->_IO_file_flags &= ~_IO_LINE_BUF|_IO_UNBUFFERED;
+      fp->_IO_file_flags &= ~(_IO_LINE_BUF|_IO_UNBUFFERED);
       if (buf == NULL)
 	{
 	  if (fp->_IO_buf_base == NULL)
@@ -96,11 +94,10 @@ _IO_setvbuf (fp, buf, mode, size)
   result = _IO_SETBUF (fp, buf, size) == NULL ? EOF : 0;
 
 unlock_return:
-  _IO_funlockfile (fp);
-  _IO_cleanup_region_end (0);
+  _IO_release_lock (fp);
   return result;
 }
-INTDEF(_IO_setvbuf)
+libc_hidden_def (_IO_setvbuf)
 
 #ifdef weak_alias
 weak_alias (_IO_setvbuf, setvbuf)
diff --git a/src/system/libroot/posix/glibc/libio/ioungetc.c b/src/system/libroot/posix/glibc/libio/ioungetc.c
index d32359bd40..a3364ea773 100644
--- a/src/system/libroot/posix/glibc/libio/ioungetc.c
+++ b/src/system/libroot/posix/glibc/libio/ioungetc.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993,1996,1997,1998,2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -36,11 +35,9 @@ _IO_ungetc (c, fp)
   CHECK_FILE (fp, EOF);
   if (c == EOF)
     return EOF;
-  _IO_cleanup_region_start ((void (*) __P ((void *))) _IO_funlockfile, fp);
-  _IO_flockfile (fp);
-  result = INTUSE(_IO_sputbackc) (fp, (unsigned char) c);
-  _IO_funlockfile (fp);
-  _IO_cleanup_region_end (0);
+  _IO_acquire_lock (fp);
+  result = _IO_sputbackc (fp, (unsigned char) c);
+  _IO_release_lock (fp);
   return result;
 }
 
diff --git a/src/system/libroot/posix/glibc/libio/ioungetwc.c b/src/system/libroot/posix/glibc/libio/ioungetwc.c
index 1bff41256c..2c65d91b0d 100644
--- a/src/system/libroot/posix/glibc/libio/ioungetwc.c
+++ b/src/system/libroot/posix/glibc/libio/ioungetwc.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993, 1996-1999, 2001, 2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -33,16 +32,14 @@ ungetwc (c, fp)
      wint_t c;
      _IO_FILE *fp;
 {
-  int result;
+  wint_t result;
   CHECK_FILE (fp, WEOF);
-  _IO_cleanup_region_start ((void (*) __P ((void *))) _IO_funlockfile, fp);
-  _IO_flockfile (fp);
+  _IO_acquire_lock (fp);
   _IO_fwide (fp, 1);
   if (c == WEOF)
     result = WEOF;
   else
-    result = INTUSE(_IO_sputbackwc) (fp, c);
-  _IO_funlockfile (fp);
-  _IO_cleanup_region_end (0);
+    result = _IO_sputbackwc (fp, c);
+  _IO_release_lock (fp);
   return result;
 }
diff --git a/src/system/libroot/posix/glibc/libio/iovdprintf.c b/src/system/libroot/posix/glibc/libio/iovdprintf.c
index 33fac6d8bd..21009eab6d 100644
--- a/src/system/libroot/posix/glibc/libio/iovdprintf.c
+++ b/src/system/libroot/posix/glibc/libio/iovdprintf.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1995, 1997-2000, 2001, 2002 Free Software Foundation, Inc.
+/* Copyright (C) 1995-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -25,7 +24,7 @@
    This exception applies to code released by its copyright holders
    in files containing the exception.  */
 
-#include "libioP.h"
+#include <libioP.h>
 #include <stdio_ext.h>
 
 int
@@ -41,29 +40,29 @@ _IO_vdprintf (d, format, arg)
 #ifdef _IO_MTSAFE_IO
   tmpfil.file._lock = NULL;
 #endif
-  _IO_no_init (&tmpfil.file, _IO_USER_LOCK, 0, &wd, &INTUSE(_IO_wfile_jumps));
-  _IO_JUMPS (&tmpfil) = &INTUSE(_IO_file_jumps);
-  INTUSE(_IO_file_init) (&tmpfil);
+  _IO_no_init (&tmpfil.file, _IO_USER_LOCK, 0, &wd, &_IO_wfile_jumps);
+  _IO_JUMPS (&tmpfil) = &_IO_file_jumps;
+  _IO_file_init (&tmpfil);
 #if  !_IO_UNIFIED_JUMPTABLES
   tmpfil.vtable = NULL;
 #endif
-  if (INTUSE(_IO_file_attach) (&tmpfil.file, d) == NULL)
+  if (_IO_file_attach (&tmpfil.file, d) == NULL)
     {
-      INTUSE(_IO_un_link) (&tmpfil);
+      _IO_un_link (&tmpfil);
       return EOF;
     }
-  tmpfil.file._IO_file_flags =
-    (_IO_mask_flags (&tmpfil.file, _IO_NO_READS,
-		     _IO_NO_READS+_IO_NO_WRITES+_IO_IS_APPENDING)
-     | _IO_DELETE_DONT_CLOSE);
+  tmpfil.file._flags |= _IO_DELETE_DONT_CLOSE;
 
-  done = INTUSE(_IO_vfprintf) (&tmpfil.file, format, arg);
+  _IO_mask_flags (&tmpfil.file, _IO_NO_READS,
+		  _IO_NO_READS+_IO_NO_WRITES+_IO_IS_APPENDING);
+
+  done = _IO_vfprintf (&tmpfil.file, format, arg);
+
+  if (done != EOF && _IO_do_flush (&tmpfil.file) == EOF)
+    done = EOF;
 
   _IO_FINISH (&tmpfil.file);
 
   return done;
 }
-
-#ifdef weak_alias
 weak_alias (_IO_vdprintf, vdprintf)
-#endif
diff --git a/src/system/libroot/posix/glibc/libio/iovsprintf.c b/src/system/libroot/posix/glibc/libio/iovsprintf.c
index dbaa53f7c8..c4432ef0f2 100644
--- a/src/system/libroot/posix/glibc/libio/iovsprintf.c
+++ b/src/system/libroot/posix/glibc/libio/iovsprintf.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993, 1997-2000, 2001, 2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -29,10 +28,7 @@
 #include "strfile.h"
 
 int
-_IO_vsprintf (string, format, args)
-     char *string;
-     const char *format;
-     _IO_va_list args;
+_IO_vsprintf (char *string, const char *format, _IO_va_list args)
 {
   _IO_strfile sf;
   int ret;
@@ -41,14 +37,11 @@ _IO_vsprintf (string, format, args)
   sf._sbf._f._lock = NULL;
 #endif
   _IO_no_init (&sf._sbf._f, _IO_USER_LOCK, -1, NULL, NULL);
-  _IO_JUMPS ((struct _IO_FILE_plus *) &sf._sbf) = &_IO_str_jumps;
-  INTUSE(_IO_str_init_static) (&sf, string, -1, string);
-  ret = INTUSE(_IO_vfprintf) ((_IO_FILE *) &sf._sbf, format, args);
-  _IO_putc_unlocked ('\0', (_IO_FILE *) &sf._sbf);
+  _IO_JUMPS (&sf._sbf) = &_IO_str_jumps;
+  _IO_str_init_static_internal (&sf, string, -1, string);
+  ret = _IO_vfprintf (&sf._sbf._f, format, args);
+  _IO_putc_unlocked ('\0', &sf._sbf._f);
   return ret;
 }
-INTDEF(_IO_vsprintf)
 
-#ifdef weak_alias
 weak_alias (_IO_vsprintf, vsprintf)
-#endif
diff --git a/src/system/libroot/posix/glibc/libio/iovsscanf.c b/src/system/libroot/posix/glibc/libio/iovsscanf.c
index 1bb475549c..f179f35c07 100644
--- a/src/system/libroot/posix/glibc/libio/iovsscanf.c
+++ b/src/system/libroot/posix/glibc/libio/iovsscanf.c
@@ -1,4 +1,4 @@
-/* Copyright (C) 1993, 1997-2000, 2001, 2002 Free Software Foundation, Inc.
+/* Copyright (C) 1993-2014 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -12,9 +12,8 @@
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
-   02111-1307 USA.
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.
 
    As a special exception, if you link the code in this file with
    files compiled with a GNU compiler to produce an executable,
@@ -40,13 +39,10 @@ _IO_vsscanf (string, format, args)
   sf._sbf._f._lock = NULL;
 #endif
   _IO_no_init (&sf._sbf._f, _IO_USER_LOCK, -1, NULL, NULL);
-  _IO_JUMPS ((struct _IO_FILE_plus *) &sf._sbf) = &_IO_str_jumps;
-  INTUSE(_IO_str_init_static) (&sf, (char*)string, 0, NULL);
-  ret = INTUSE(_IO_vfscanf) ((_IO_FILE *) &sf._sbf, format, args, NULL);
+  _IO_JUMPS (&sf._sbf) = &_IO_str_jumps;
+  _IO_str_init_static_internal (&sf, (char*)string, 0, NULL);
+  ret = _IO_vfscanf (&sf._sbf._f, format, args, NULL);
   return ret;
 }
-
-#ifdef weak_alias
 weak_alias (_IO_vsscanf, __vsscanf)
 weak_alias (_IO_vsscanf, vsscanf)
-#endif
